package at.jku.ssw.graph;

/** A vertex of a graph. */
public class Vertex implements Cloneable {

	public final char value;
	public final boolean isRoot;
	public boolean marked;
	public Vertex parent;
	public int minWeight = 0;
	public int distance = 0;

	/** Creates a vertex with a character value. */
	public Vertex(char value) {
		this(value, false);
	}

	/** Creates a vertex or a root vertex with a character value. */
	public Vertex(char value, boolean isRoot) {
		this.value = value;
		this.isRoot = isRoot;
	}

	/**
	 * Resets the transient fields of this vertex.
	 */
	public void reset() {
		minWeight = 0;
		distance = 0;
		parent = null;
		marked = false;
	}

	/**
	 * Returns a {@link #reset() reseted} clone of this vertex.
	 */
	@Override
	public Vertex clone() {
		return new Vertex(value, isRoot);
	}

	@Override
	public String toString() {
		return String.valueOf(value);
	}
}