package at.jku.ssw.graphviz;

import at.jku.ssw.graph.Graph;

/**
 * A maker of dot strings for GraphViz in order to display data structures.
 */
public class DotMaker {

	/**
	 * Creates a dot string for a graph.
	 */
	public static String makeDotForGraph(Graph graph) {
		return new DotMakerGraph(graph).getDot();
	}

	/**
	 * Creates a dot string which represents the heap.
	 */
	public static String makeDotForHeap(Object[] values) {
		StringBuilder b = new StringBuilder();
		b.append("digraph Heap {\n");
		for (int i = 1; i < values.length; i++) {
			if (values[i] == null) {
				throw new IllegalArgumentException(
						"Array must not contain null values." + " Please correct array length using Arrays.copyOf.");
			}
			String name = String.format("node%03d[label=\"%s\"]", i, values[i].toString());
			b.append(name + ";\n");
			if ((i * 2) < values.length) {
				b.append(String.format("node%03d", i));
				b.append("->");
				b.append(String.format("node%03d", i * 2) + ";");
				b.append("\n");
				if ((i * 2 + 1) < values.length) {
					b.append(String.format("node%03d", i));
					b.append("->");
					b.append(String.format("node%03d", i * 2 + 1) + ";");
					b.append("\n");
				}
			}
		}
		b.append("}");
		return b.toString();
	}
}
